/*
 Representación dun número en decimal con caracteres ASCII.

      Almacénase a representación como cadea, pondo 0's 
      nas posicións máis significativas se é necesario.

*/
      .data
num:  .hword      457
res:  .space      5

      .text
main: ldr      r4, =res      @ dirección do resultado
      mov      r3, #5        @ contador de caracteres
      ldr      r0, =num
      ldr      r0, [r0]      @ numero a converter

outro:                       @ pasamos (o que queda d)o número
      bl       div10         @ dividimos por 10
                             @ o resto en r1 será o novo díxito.
      add      r1, #'0'      @ pasamos a ascii
      sub      r3, r3, #1
      strb     r1, [r4, r3]  @ almacenamos na súa posición

      cmp      r0, #0        @ terminamos?
      beq      ecero

      cmp      r3, #0        @ o último díxito era o de orde 5?
      beq      fin

ecero:      
      mov      r0, #'0'      @ enchemos con ceros, é dicir,

outrop:      
      sub      r3, r3, #1    @ pomos 0's nos caracteres que 
      strb     r0, [r4, r3]  @ faltan
      cmp      r3, #0
      bne      outrop
      
fin:  wfi

/*
 Subprograma para dividir por 10.

      Entrada: en r0 unha palabra co dividendo
      Saída:  en r0 o cociente, e en r1 o resto

      Neste exemplo, realizamos a división por restas sucesivas
      (algoritmo de Euclides da división).
*/
div10:      
      mov      r2, #0         @ init cociente a 0 (r2)

bucle:      
      cmp      r0, #10        @ divisor menor que 10?
      blt      fins           @ se o é, acabamos

      add      r2, r2, #1     @ sumamos 1 ao cociente
      sub      r0, r0, #10    @ restamos 10 do dividendo
      b        bucle                  

fins:     
      mov      r1, r0         @ almacenamos o resto
      mov      r0, r2         @ e o cociente
      mov      pc, lr
      .end
