      .data
zona: .hword 2, 1, 7, 8, 5, 6, 4, 9, 3      
      .equ   tam, 9

      .text

/* Temos que rotar a zona dúas veces */

main: ldr  r0,=zona    @ r0: dirección da zona
      mov  r1,#tam     @ r1: tamaño
      bl   rota        @ rotamos

      ldr  r0,=zona 
      mov  r1,#tam
      bl   rota        @ rotamos outra vez 
      wfi  

/*
 rota: Subprograma para rotar as medias palabras
 almacenadas nunha zona de memoria.
 Argumentos:
      r0: dirección de comezo da zona.
      r1: tamaño (en medias palabras) da zona.
*/
rota:
/*    
Primeiro comprobamos se hai medias palabras que rotar
*/

      cmp  r1,#1       @ se a zona non ten polo menos dúas
      ble  feito        @ medias palabras, terminamos.

      sub  r1,r1,#1    @ calculamos o fin da zona
      lsl  r1,#1         
      add  r1,r1,r0    @ r1: apunta agora ao último elemento

      ldrh r2,[r1]     @ movemos o primeiro ao
      ldrh r3,[r0]     @ último a través de r3
      strh r3,[r1]

outro: ldrh r3,[r0,#2] @ movemos cara abaixo
      strh r3,[r0]     @ desde o segundo
      add  r0,#2
      cmp  r0, r1            
      bne  outro

      sub  r0,#2
      strh r2,[r0]     @ movemos o último ao penúltimo

feito: mov  pc,lr      @ e terminamos
      .end
