
	.data
cad:	.byte 	0xa1, 'O', 'l', 'a', ' ', 'r', 'a', 'p', 'a', 'c', 'i'
	.byte 	0xf1, 'o', 's ', '!', 0x00
res:	.space	20

   .text
main:
   ldr   r4, =cad     @ r4: dir. da cadea de partida
   ldr   r5, =res     @ r5: dir. do resultado
buc:   
   ldrb  r0, [r4]     @ r0: cargamos un carácter   
   cmp   r0, #0       @ vemos se fin de cadea
   beq   acab

   bl    btoutf8      @ convertemos o carácter utilizando 
   cmp   r0, #0x80    @ o subprograma; vemos se é de 2 bytes
   blt   so1

   strb  r0, [r5, #1] @ almacenamos o byte menos signific. (de segundo)
   lsr   r0, r0, #8   @ preparamos o byte máis significativo (0xCX)
   strb  r0, [r5, #0] @ para almacenar o 0xCX no seu sitio
   add   r5, r5, #2   @ incrementamos o punteiro
   b     outro

so1:   
   strb  r0, [r5]     @ almacenamos tal cal
   add   r5, r5, #1
outro:   
   add   r4, r4, #1
   b     buc

acab:    wfi


/*

 btoutf8: subprograma para converter caracteres no rango  
 0x00 a 0xff en caracteres UTF8 de 1 ou 2 bytes.

   entrada: r0, byte menos significativo, carácter de entrada
   saída:  r0, conversión de 1 ou 2 bytes. resto a cero.
*/
btoutf8:
   mov   r1,#ff
   and   r0,  r0, r1 @ quedamos co byte menos significativo
   cmp   r0, #0x80
   blt   xaconv      @ carácter de 1 byte. Non nay que convertelo.

   ldr   r2, =0xC000 @ máscara para o byte máis significativo
   ldr   r3, =0xff00 @ máscara para borrar o byte máis sign.

   lsl   r1, r0, #2  @ byte de r1: o byte máis significativo
   orr   r1, r1, r2  @ do resultado
   and   r1, r1, r3

   mov   r2,#0x3f    @ cambiamos os dous bits máis signif.
   and   r0, r0, r2  @ de r0 por 0b10
   mov   r2,#0x80
   orr   r0, r0, r2

   orr   r0, r0, r1  @ e montamos todo en r0

xaconv:   
   mov   pc,lr
   .end