
     .data
val: .word  0xa7b5ff90  @ dato de exemplo
res: .space 10          @ resultado

   .text
main:
   ldr   r4, =val     @ dirección do dato
   ldr   r5, =res     @ dirección do resultado
@
@ pomos o marcador hex '0x'
@
   mov   r3, #'0'
   strb  r3, [r5]
   mov   r3, #'x'
   strb  r3, [r5, #1]
   add   r5, r5, #2
@
@ convertemos e almacenamos
@
   mov   r6, #7       @ contador de díxitos
   ldr   r4, [r4]     @ cargamos o número en r4

outro:    
   mov   r0, r4       
   bl    hextoa       @ convertemos o nibble menos significativo
   strb  r0, [r5, r6] @ almacenámolo no seu sitio
   cmp   r6, #0       @ terminamos?
   beq   final      
 
   lsr   r4, r4, #4   @ desprazámolo un nibble
   sub   r6, r6, #1   @ restamos 1 do contador / punteiro
   b     outro        @ e outra vez

final:
   wfi

/* subrutina para pasar un díxito en binario a ASCII en hexadecimal
   entrada: r0 díxito en binario (4 bits menos significativos). 
      Ignórase o resto.
   saída:  r0: carácter ASCII do número (8 bits menos  
      significativos). Resto a cero.
*/

hextoa:   
   mov   r1, #0x0f     @ enmascaramos todo menos o nibble menos 
   and   r0, r0, r1    @ significativo
   cmp   r0, #0x09     @ vemos se '0' - '9' ou 'A' - 'Z'
   bhi   msr1

   add   r0, r0, #'0'  @ menor que 9 
   b     dsr1

msr1:    
   add   r0, r0, #0x37 @ maior que 9 : 0x0A + 0x37 = 0x41 = 'A'
dsr1:    
   mov   pc,lr
   .end