
      .data
strm: .byte   0x00, 0x01, 0x02, 0x70, 0x71, 0x72, 0x0f, 0x04

   .text
main:
   ldr   r4, =strm  @ r4: para navegar a lista de números
bucle:   
   ldrb  r0, [r4]
   cmp   r0, #0x04
   beq   fin        @ se é EOT, terminamos (sen convertelo, é par)

   bl    setppar    @ chamamos ao subprograma para 
   strb  r0, [r4]   @ converter este carácter.
   add   r4, r4, #1
   b     bucle

fin:   wfi

/*
 setppar: subprograma que conta o numero de bits a 1 
 no byte menos significativo de r0, 
 e devolve en r0 o byte coa paridade correcta.

Entrada: r0: byte a comprobar.
Saída:  r0: con paridade par.

*/

setppar:   
   mov   r3, r0      @ gardamos unha copia de r0
   lsl   r3, r3, #24 @ desprazamos o byte ata que quede ao bordo
   mov   r2, #0      @ contador de bits a 1
   mov   r1, #7      @ contador de desprazamentos

pbuc:   
   lsl   r3, r3, #1  @ o bit menos significativo vai ao signo
   bpl   nonsuma      @ se non é un, pasamos ao seguinte

   add   r2, r2, #1  @ incrementamos o contador duns
nonsuma:   
   sub   r1, r1, #1
   bne   pbuc        @ ao seguinte se non acabamos

   lsr   r2, #1      @ vemos se a conta é par ou impar
   bcc   epar       @ se é par, acabamos

   mov   r1, #0x80   @ máscara para activar o bit de paridade
   orr   r0, r0, r1  @ activámolo

epar:   
   mov   pc,lr
   .end
